%%
clc; clear; close all;

gen_gp_data_toy = 1;
gen_gp_data_rlz = 0;

if gen_gp_data_toy
    % f = @(x)(5*sin(x+sin(x)));
    f = @(x)(5*sinc(x));
    nr_data = 500;
    input = linspace(-5, 5, nr_data)';
    output = f(input);
    gp_ref = struct('nr_data', nr_data, 'input', input, 'output', output);
    % Plot
    figure; set(gca,'FontSize', 12); plot(input, output); grid on; axis equal; title('Toy Data');
    % Save
    save('gp_data_toy.mat', 'gp_ref');
end


if gen_gp_data_rlz
    nr_data = 100;
    input = linspace(0, 10, nr_data)';
    hyp = struct('g2', 1E0, 'l2', 1E0, 'w2', 1E-8);
    K = kernel_se(input, input, hyp); 
    output = mvnrnd(zeros(nr_data, 1), K)';
    gp_ref = struct('nr_data', nr_data, 'input', input, 'output', output);
    % Plot
    figure; set(gca,'FontSize', 12); plot(input, output); grid on; axis equal; title('GP Realization');
    % Save
    save('gp_data_rlz.mat', 'gp_ref');
end
