%% 
ccc;

%% 1. Do regression using GPR
clc; clear; % close all; 
% 1. Training data (nr_data, input, output, lev)
nr_data = 7;
% input  = [+1.0  +2.0  +3.0  +4.0  +4.5  +5.0  +7.0  ]';
% output = [+4.0  +2.0  +9.0  +5.5  +9.0  +8.0  +9.0 ]';
% lev    = [+1.0  +1.0  +0.5  +0.6  +1.0  +0.2  +0.3  ];
input  = [+1.0  +2.0  +3.0  +4.0  +4.5  +4.5  +4.5  +5.0  +7.0  ]';
output = [+4.0  +2.0  +9.0  +5.5  +9.0  +4.0  +0.0  +8.0  +9.0 ]';
lev    = [+1.0  +1.0  +1.0  +1.0  +1.0  +1.0  +1.0  +1.0  +1.0  ];
gp_train = struct('nr_data', nr_data, 'input', input, 'output', output);
ref_input = linspace(0, 10, 1E2)';
% Hyperparameters are SHARED among GPs
hyp = struct('g2', 5E0, 'l2', 2E0, 'w2', 1E-6);
% 2. Stationary GPR (lev = ones)
sgpr_struct = init_lgpr(input, output, @kernel_lev_cos, hyp);
sgpr_result = lgpr(sgpr_struct, ref_input);
plot_sgpr = 0;
% 3. Proposed Leveraged GPR (ICRA 2015)
lgpr_struct = init_lgpr(input, output, @kernel_lev_cos, hyp, lev);
lgpr_result = lgpr(lgpr_struct, ref_input);
% 4. Leveraged GPR (modified to be always Positive)
lpgpr_struct = init_lgpr(input, output, @kernel_lev_cos_pos, hyp, lev);
lpgpr_result = lgpr(lpgpr_struct, ref_input);
% 5. Principle Component Gaussian Process Regression (IROS 2014)
pgpr_struct = sgpr_struct;
Th = 1E-5; rank = nr_data-1; % out of 'nr_data'
[P, X] = L1_ARG(pgpr_struct.K, rank, 0, Th, 2, 1e-6, 1e-1);
LR = P*X; 
pcgp_Vm = eig_dec(LR, rank);
Vm_pinv = pcgp_Vm*pcgp_Vm';
pgpr_struct.invKmeanzeroY = Vm_pinv * (pgpr_struct.output - repmat(pgpr_struct.mean_output, pgpr_struct.nr_data, 1));
pgpr_result = lgpr(pgpr_struct, ref_input);
% 6. Heuristic GPR (set sig2w differently based on levs)
hgpr_struct = init_hgpr(input, output, @kernel_lev_cos, hyp, lev);
hgpr_result = lgpr(hgpr_struct, ref_input);

% Plot things 
plot_gps(sgpr_result, lgpr_result, lgpr_struct, lpgpr_result, pgpr_result, hgpr_result, ref_input, output, gp_train, lev);


%% 









