function [grad, lik] = der_marginal_likelihood(gp_train, kfun, dkfun, hyp, param)
%
% ־ Ϳ ؼ Marginal likelihood derivative w.r.t. param Ѵ. 
%
nr_data = gp_train.nr_data;
mean_output = mean(gp_train.output);
Y = gp_train.output - repmat(mean_output, nr_data, 1);


K = kfun(hyp);
dK = dkfun(hyp, param);
alpha = K \ Y;

% Compute gradient
grad = 0.5*trace((alpha*alpha' - inv(K))*dK);

% Compute log-likelihood
lik = -0.5*Y'/K*Y - 0.5*log(det(K)) - gp_train.nr_data/2*log(2*pi);





