function field_struct = gen_gp_field(stage_struct, kfun)
%
% [input]
% stage
% kernel
%
% [output]
% field
% 
K = kfun(stage_struct.points, stage_struct.points);
z = chol(K)'*randn(stage_struct.nr_points, 1);
Z = reshape(z, stage_struct.yres, stage_struct.xres);

field_struct.xmin = stage_struct.xmin;
field_struct.xmax = stage_struct.xmax;
field_struct.ymin = stage_struct.ymin;
field_struct.ymax = stage_struct.ymax;

field_struct.xres = stage_struct.xres;
field_struct.yres = stage_struct.yres;
field_struct.xgrid = stage_struct.xgrid;
field_struct.ygrid = stage_struct.ygrid;
field_struct.zmean = mean(mean(Z));
field_struct.zdata = Z - mean(mean(Z));
field_struct.zrange = [min(min(field_struct.zdata)) max(max(field_struct.zdata))];
field_struct.zmin = field_struct.zrange(1);

field_struct.nr_points = stage_struct.nr_points;
field_struct.points = stage_struct.points;

z_diff = field_struct.zrange(2) - field_struct.zrange(1);
field_struct.axis = [field_struct.xmin field_struct.xmax ...
    field_struct.ymin field_struct.ymax ...
    field_struct.zrange(1)-z_diff/2 field_struct.zrange(2)+z_diff/2 ];


