function stage = init_stage(axis_info, res_info)
%
% Generate stage struct for 2D sensory field
%
stage.xmin = axis_info(1);
stage.xmax = axis_info(2);
stage.ymin = axis_info(3);
stage.ymax = axis_info(4);

stage.xres = res_info(1);
stage.yres = res_info(2);
stage.xgrid = linspace(stage.xmin, stage.xmax, stage.xres);
stage.ygrid = linspace(stage.ymin, stage.ymax, stage.yres);
[mesh_X, mesh_Y] = meshgrid(stage.xgrid, stage.ygrid); 

% (x, y) points in column direction 
stage.points = [mesh_X(:) mesh_Y(:)]; 
stage.nr_points = length(stage.points);



