function K_lev = kernel_lev_cos_mod(X1, X2, lev1, lev2, hyp)
%
% Modified Leveraged kernel function with cos function 
%
g2 = hyp.g2; 
w2 = hyp.w2;
l2 = hyp.l2;

nr_X1 = size(X1, 1);
nr_X2 = size(X2, 1);
K_lev = zeros(nr_X1, nr_X2);
for i = 1:nr_X1
    for j = 1:nr_X2
        lev_i = lev1(i);
        lev_j = lev2(j);
        x_i = X1(i, :);
        x_j = X2(j, :);
        
        lev_diff = abs(lev_i - lev_j);
        x_dist_sq = norm(x_i - x_j)*norm(x_i - x_j);
        
        
        % This guy is the miodified (but not PSD..)
        K_lev(i, j) = lev_diff/2 + cos(lev_diff*pi/2)*exp(-x_dist_sq/l2);
        
        % This guy is the original (PSD!)
        % K_lev(i, j) = cos(lev_diff*pi/2)*exp(-x_dist_sq/l2);
        

    end
end

if (nr_X1 == nr_X2) && (nr_X1 > 1)
    K_lev = K_lev + w2*eye(nr_X1, nr_X1);
end