function lgp_result = lgpr(lgp_struct, x_test)

nr_test = size(x_test, 1);
nr_data = size(lgp_struct.output, 2);

lgp_result.mean = zeros(nr_test, nr_data);
lgp_result.var  = zeros(nr_test, 1);

for i = 1:nr_test
    % Comptute kernel vector
    lev_default = 1;
    k_vector = lgp_struct.kernel_test(x_test(i, :), lgp_struct.input ...
        , lev_default, lgp_struct.lev);
    
    % 1. Predictive mean
    lgp_result.mean(i, :) = k_vector*lgp_struct.invKmeanzeroY ...
        + repmat(lgp_struct.mean_output, 1, 1);
    
    % 2. Predictive variance
    lgp_result.var(i) = abs(lgp_struct.kernel_test(x_test(i, :), x_test(i, :) ...
        , lev_default, lev_default) ...
        - k_vector*lgp_struct.invK*k_vector');
end

