function fig_field = plot_field_meas(field_struct, meas_struct)

fig_field = figure(); scrsz = get(0,'ScreenSize'); 
set(fig_field,'Position', [0.2*scrsz(3),0.2*scrsz(4),0.3*scrsz(3),0.4*scrsz(4)]);
axes('Parent', fig_field, 'Position', [0.05, 0.08, 0.95, 0.86] );
hold on; 
surfc(field_struct.xgrid, field_struct.ygrid, field_struct.zdata, 'LineWidth', 1);
colormap jet; % colorbar; caxis(field_struct.zrange); 
% shading interp; lighting phong;
for i = 1:meas_struct.nr_data
    x = meas_struct.input(i, 1);
    y = meas_struct.input(i, 2);
    zval = meas_struct.output(i);
    plot3([x x], [y y], [field_struct.zmin zval-.1], 'b-', 'LineWidth', 1);
    plot3(x, y, field_struct.zmin, 'o', 'LineWidth', 2, 'MarkerEdgeColor','k', 'MarkerFaceColor', 'g', 'MarkerSize', 13);
    text(x, y, field_struct.zmin, sprintf('   %.2f', zval), 'FontSize', 12);
end
hold off; view(-15, 30); xlabel('X'); ylabel('Y'); zlabel('Z');
axis(field_struct.axis); grid on;
title('Gaussain Process Realization and Measurements', 'FontSize', 15);
axes('Parent', fig_field, 'Position', [0.7, 0.69, 0.3, 0.25]); hold on;
contour(field_struct.xgrid, field_struct.ygrid, field_struct.zdata, 'LineWidth', 1);
plot(meas_struct.input(:, 1), meas_struct.input(:, 2), 'ko');
xlabel('X'); ylabel('Y'); axis equal; 

