function fig = plot_gps(sgpr_result, lgpr_result, lgpr_struct, lpgpr_result, pgpr_result, hgpr_result, ref_input, output, gp_train, lev)

fig = figure; clf; scrsz = get(0,'ScreenSize');
set(fig,'Position', [0.2*scrsz(3),0.2*scrsz(4),0.4*scrsz(3),0.35*scrsz(4)]);
subaxes(fig, 1, 1, 1, 0.1, 0.15);
set(gca,'FontSize', 14); hold on; colors = lines(4);

hlpgprv = 0; % hlpgprv = fill_btw(ref_input, lpgpr_result.mean-lpgpr_result.var, lpgpr_result.mean+lpgpr_result.var, [.95 .8 .99]);
hlgprv = fill_btw(ref_input, lgpr_result.mean-lgpr_result.var, lgpr_result.mean+lgpr_result.var, [.95 .95 .99]);
plot([ref_input(1, :) ref_input(end, :)], [lgpr_struct.mean_output lgpr_struct.mean_output], 'b--', 'LineWidth', 2);
href = 0;% href   = plot(ref_input, gp_ref.output, '-', 'Color', colors(1, :), 'LineWidth', 2);
htrain = plot(gp_train.input, gp_train.output, 'o', 'Color', 'k', 'LineWidth', 2, 'MarkerSize', 15);

hsgpr  = plot(ref_input, sgpr_result.mean,  '-', 'Color', colors(1, :), 'LineWidth', 2);
hlpgpr = plot(ref_input, lpgpr_result.mean, '-', 'Color', colors(2, :), 'LineWidth', 2);
hpgpr  = plot(ref_input, pgpr_result.mean,  '-', 'Color', colors(3, :), 'LineWidth', 2);
hhgpr  = plot(ref_input, hgpr_result.mean,  '-', 'Color', colors(4, :), 'LineWidth', 2);

hlgpr  = plot(ref_input, lgpr_result.mean,  '--', 'Color', 'r', 'LineWidth', 4);

for i = 1:length(lev)
    str = sprintf('  %.2f', lev(i));
    text(gp_train.input(i), gp_train.output(i), str, 'FontSize', 15);
end

smart_legend([href, htrain, hlgpr, hlgprv, hsgpr, hlpgpr, hlpgprv, hpgpr, hhgpr] ...
    , {'Reference Function', 'Training Data', 'L-GPR', 'L-GPR Variance' ...
    , 'S-GPR', 'LP-GPR', 'LP-GPR Variance', 'PC-GPR', 'H-GPR'} ...
    , 'SouthEast');
xlabel('Input'); ylabel('Output');
grid on; axis([ref_input(1) ref_input(end) min(output)-5 max(output)+5]); % axis equal;
title('Gaussian Process Regression Methods');

