function fig = plot_ref_recon_opt_fields( ...
    field_struct, recon_field, recon_field_noisy, recon_field_opt, meas_struct, rand_idx, idx_opt)


fig = figure(); scrsz = get(0,'ScreenSize'); colormap bone;
set(fig,'Position', [0.2*scrsz(3),0.2*scrsz(4),0.6*scrsz(3),0.6*scrsz(4)]);
xm = .05; ym = .1;


subaxes(fig, 2, 2, 1, xm, ym); hold on;
% pcolor(field_struct.xgrid, field_struct.ygrid, field_struct.zdata); 
surfc(field_struct.xgrid, field_struct.ygrid, field_struct.zdata, 'LineWidth', 1);
xlabel('X'); ylabel('Y'); view(15, 32); axis(field_struct.axis);
colorbar; caxis(field_struct.zrange); grid on;
title('Reference Field', 'FontSize', 15);



subaxes(fig, 2, 2, 2, xm, ym); hold on;
surfc(field_struct.xgrid, field_struct.ygrid, recon_field, 'LineWidth', 1);
for i = 1:meas_struct.nr_data
    x = meas_struct.input(i, 1);
    y = meas_struct.input(i, 2);
    z = meas_struct.output(i);
    easy_plot3([x x], [y y], [field_struct.zmin z], '-', 'k', 1, 7, 'w');
    easy_plot3(x, y, z, 'o', 'k', 1, 7, 'w');
end
xlabel('X'); ylabel('Y'); view(15, 32); axis(field_struct.axis);
colorbar; caxis(field_struct.zrange); grid on;
title('Reconstructed Field with Reference Data', 'FontSize', 15);




subaxes(fig, 2, 2, 3, xm, ym); hold on;
surfc(field_struct.xgrid, field_struct.ygrid, recon_field_noisy, 'LineWidth', 1);
for i = 1:meas_struct.nr_data
    x = meas_struct.input(i, 1);
    y = meas_struct.input(i, 2);
    z = meas_struct.output(i);
    easy_plot3([x x], [y y], [field_struct.zmin z], '-', 'k', 1, 7, 'w');
    easy_plot3(x, y, z, 'o', 'k', 1, 7, 'w');
end
x = meas_struct.input(rand_idx, 1);
y = meas_struct.input(rand_idx, 2);
z = meas_struct.output(rand_idx);
easy_plot3([x x], [y y], [field_struct.zmin z], '-', 'm', 2, 7, 'm');
easy_plot3(x, y, z, 'o', 'k', 2, 10, 'm');
xlabel('X'); ylabel('Y'); view(15, 32); axis(field_struct.axis);
colorbar; caxis(field_struct.zrange); grid on;
title('Reconstructed Field with Noisy Data', 'FontSize', 15);



subaxes(fig, 2, 2, 4, xm, ym); hold on;
surfc(field_struct.xgrid, field_struct.ygrid, recon_field_opt, 'LineWidth', 1);
for i = 1:meas_struct.nr_data
    x = meas_struct.input(i, 1);
    y = meas_struct.input(i, 2);
    z = meas_struct.output(i);
    easy_plot3([x x], [y y], [field_struct.zmin z], '-', 'k', 1, 7, 'w');
    easy_plot3(x, y, z, 'o', 'k', 1, 7, 'w');
end
x = meas_struct.input(rand_idx, 1);
y = meas_struct.input(rand_idx, 2);
z = meas_struct.output(rand_idx);
easy_plot3([x x], [y y], [field_struct.zmin z], '-', 'm', 2, 7, 'w');
easy_plot3(x, y, z, 'o', 'k', 2, 10, 'm');

x = meas_struct.input(idx_opt, 1);
y = meas_struct.input(idx_opt, 2);
z = meas_struct.output(idx_opt);
easy_plot3([x x], [y y], [field_struct.zmin z], '-', 'r', 2, 7, 'w');
easy_plot3(x, y, z, 'o', 'k', 2, 10, 'r');

xlabel('X'); ylabel('Y'); view(15, 32); axis(field_struct.axis);
colorbar; caxis(field_struct.zrange); grid on;
title('Reconstructed Field with Optimized Leverages', 'FontSize', 15);

